<?php

/*
*	Syndeo CMS (former Site@School)
* 	is a website management system designed for primary schools.
* =============================================================================== *
* History Site@School:
* Original idea, coding (version 1.0) and design : Mark de Haan (mark@starwave.nl)
* Ideas, improvements, expansions (versions 1.1 - 2.4): 
* Karin Abma, Dirk Schouten and Fred Stuurman
* Coding version 1.1 - 2.4.10 Fred Stuurman
* =============================================================================== *
* Syndeo CMS Software Version: 3.0.00 
* Copyright (C) 2007-2011: Fred Stuurman (fc.stuurman@gmail.com)
*
* index.php: last changed 16/07/2011 by Fred Stuurman (fc.stuurman@gmail.com)
* $Id$
* =============================================================================== *
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.

* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
* See the GNU General Public License in the starnet directory for more details.
*/

$old_error_reporting = error_reporting(0); // switch off error reporting during sanity checks

define('IN_SAS', true);
define('SAS_VERSION', '3.0.00');

//initialize variables
$page = 0;
$section = 0;
$category = "";
$themelocation = "";
$cmsdir = 'starnet';

// SANITY CHECK #1 - is there an existing installation at the location we expect?
if (!file_exists($cmsdir . '/configuration/database.inc.php'))
{
	error_exit('010');
}

// SANITY CHECK #2 - do we have a connection to a working database?
include ($cmsdir . '/configuration/database.inc.php');
$db = new mysqli($db_server, $db_username, $db_password, $db_name);

/*
 * Still here? Must have valid database in our hands then. Carry on...
 */

include ($cmsdir . "/core/common.inc.php"); //include common functions
require ($cmsdir . "/core/session.php");  //build a session

unset ($sas_config);
$query = "SELECT config_key,config_value FROM $table_configuration";  //read all the configuration items
$result = mysqli_query($db, $query);

while ($config_list = mysqli_fetch_array($result))
{
	$sas_config[$config_list[0]] = $config_list[1];
	//put them in the config array
}

// SANITY CHECK #4 - do we have a template value?
if ($sas_config['theme'] == "") //if theme config value is empty, there is a problem with the site.
{
	error_exit('050');
}

error_reporting($old_error_reporting); // switch on error reporting after sanity checks
//from here on we should be able to mail other errors to the site admin.
//so set our own error handler (in common.inc.php)
set_error_handler('myErrHandler');

// setting variables to global
if (IsSet ($_GET['page']))
{
	$page = intval($_GET['page']);
}
if (IsSet ($_GET['section']))
{
	$section = intval($_GET['section']);
}
if (IsSet ($_GET['category']))
{
	$category = sql_addslashes(strip_tags($_GET['category']));
}
if (IsSet ($_GET['site']))	// we get protected or public via the URL link
{
	$website = $_GET['site'];
	$_SESSION['site'] = $website;
}
elseif (IsSet ($_SESSION['site']))
{
	$website = $_SESSION['site'];
}
else
{
	$website = "";
}

if ($_GET['logout'] == "yes") // logging out, destroying session data
{
	mysqli_query($db, "UPDATE $table_studentpages SET approved = '' WHERE approved = $_SESSION[userid]");
	//clear approved for pages which might be in use by pupil/teacher
	session_unset();
	session_destroy();

	if ($website == "protected")
	{
		//if we go back to normal site we don't know page and section
		header("Location: index.php");
	}
}
if (IsSet ($_SESSION['userid']) AND (($_SESSION['user_type'] == 2) or ($_SESSION['user_type'] == 22) OR ($_SESSION['user_type'] == 20)) AND $_SESSION['site'] == "protected")
	//are we allowed to go to protected area, then switch to the protected tables
{
	$table_sections = $dbprefix . "prot_sections";
	$table_pages = $dbprefix . "prot_pages";
	$_SESSION['site'] = $website;
	$themelocation = $sas_config['protected_theme'];	//set the protected theme
}
else
{
	$themelocation = $sas_config['theme'];	//set normal theme
}

$sitename = $sas_config['sitename']; //selecting the title of the site
$check_sessioncode = $sas_config['sessioncode'];  //selecting the sessioncode, can be used for security
$media = $sas_config['media_dir']; //media directory
$studentpages = $sas_config['studentpages_dir']; //pupilpages directory
$userpath = $sas_config['user_path'];  //get the directoryname of the cms
if (substr($userpath, 0, 1) == "/")
{
	$userpath = substr($userpath, 1);	//strip first slash
}
$serverpath = $sas_config['serverpath']; //get the document root of the site

if (strrpos($serverpath, '/') != strlen($serverpath) - 1)
{
	$serverpath .= '/';	//add last slash if not present
}
$serverpath = $serverpath . $userpath;
$site_url = $sas_config['url']; //select the URL, used for images, downloads, links etc.

$language = $sas_config['language'];	//select the language, used for module language files
load_language($cmsdir . '/', '/'); 	//load language file

$query = "SELECT name FROM $table_sections WHERE id = '" . $section . "'"; //selecting the title of the section
$result = mysqli_query($db,$query) or trigger_error(mysqli_error($db).'"<br>Query : "' . $query . '".',E_USER_WARNING); 
if (mysqli_num_rows($result) > 0)
{
	$sectiontitle = mysqli_result($result, 0);
}
else
{
	$section = 0 ; //section doesn't exists, reset section number to 0.
}
unset ($query);
unset ($result);

if ((!IsSet ($section)) OR ($section == 0)) //select startsection if no section was selected
{
	if ($website == "protected")
	{
		$section = $sas_config['protected_startsection'];
	}
	else
	{
		$section = $sas_config['startsection'];
	}
}

$query = "SELECT frontpage, name FROM $table_sections WHERE id = '" . $section . "'";
$result = mysqli_query($db, $query) or trigger_error(mysqli_error($db).'"<br>Query : "' . $query . '".',E_USER_WARNING);

if ((!IsSet ($page)) OR ($page == 0)) //select startpage of section if no page was selected
{
	$page = mysqli_result($result, 0, 0);
	$sectiontitle = mysqli_result($result, 0, 1);
}
$frontpage = mysqli_result($result, 0, 0);	//we need this if the visitor provides a wrong page_id
unset ($query);
unset ($result);
	
//selecting the title of the page
$query = "SELECT name FROM $table_pages WHERE hidden != 'yes' AND id = '" . $page . "'";
$result = mysqli_query($db, $query) or trigger_error(mysqli_error($db).'"<br>Query : "' . $query . '".',E_USER_WARNING); 

if (mysqli_num_rows($result) == 0)
{
	if(($frontpage == 0) OR ($page == 0))
	{
		//section has no frontpage, give error
		print $sas_lang['section_no_pages'] ;
		exit;
	}
	else
	{
		//page id does not exist, use the frontpage from the section.
		$page = $frontpage ;
	}
}
else
{
	$pagetitle = mysqli_result($result, 0) ;
}
unset ($query);
unset ($result);

//do we have print flag on?
if (isset ($_GET['print']) AND ($_GET['print'] == "yes"))
{
	print "<html>\n
			<head>\n";
	print "<title>$sitename - $pagetitle</title>";
	
	if( file_exists($cmsdir . "/themes/$themelocation/style.css"))
	{
		//see if there is a style.css present
		print "<style type=\"text/css\" media=\"print\">";
		include($cmsdir . "/themes/$themelocation/style.css");
		print "</style>\n";
	}
	if( file_exists($cmsdir."/core/css.php"))
	{
		//see if there is module loaded and get its CSS definition from modules table.
		include($cmsdir."/core/css.php");
	}
	print "<body>\n";

	$query = "SELECT module, content FROM $table_pages WHERE hidden != 'yes' AND id = '" . $page . "'";
	$result = mysqli_query($db, $query);

	if (mysqli_num_rows($result) > 0)
	{
		$module = mysqli_result($result, 0, 0);
		$content = mysqli_result($result, 0, 1);
		unset ($query);
		unset ($result);
	}
	
	print "<table height=\"490\" border=\"0\" cellpadding=\"10\" cellspacing=\"0\" width=\"100%\">
				<tr><td valign=\"top\" width=\"100%\">";
	if ($module != '')
	{
		if (file_exists($cmsdir . "/modules/$module"))
		{
			include ($cmsdir . "/modules/$module");
		}
	}
	else
	{
		$content = str_replace("../", "", $content);
		print $content;
	}

	print "</td></tr>
			</table>
			</body>
			</html>\n";
}
else // including the theme file
{
	include ($cmsdir . "/themes/$themelocation/main.inc.php");
}
//save page statistics
save_stats($page,$section) ;
//end of index.php

function error_exit($conditioncode, $ttl = "Error")
{
	/*---------------------------------
	 * Show a 'cryptic' condition code + exit
	 */
	echo "<html>\n<head>\n<title>$ttl</title>\n</head>\n<body>\n" .
	"<h1>$ttl</h1>\n" .
	"<b>There is a problem with this site.</b>\n<p>\n" .
	"Please contact the site owner mentioning the " .
	"following condition code:\n<p>\n<b>" .
	SAS_VERSION . '/' . $conditioncode . "</b>\n<p>\n" .
	"Thank you for your cooperation!\n</body>\n</html>\n";
	exit;
} /* error_exit() */

function save_stats($page,$section)
{
	global $db, $dbprefix, $table_pages, $website ;

$ip = $_SERVER["REMOTE_ADDR"];
//log the ip address
$d = date("Y-m-d");

$table_stats = $dbprefix . "stats";
//update or insert into the stats table
	if (IsSet ($website) AND ($website == "protected") AND ($_SESSION['user_group'] > 0))
	{
		$table_pages = $dbprefix . "prot_pages";
		mysqli_query($db, "UPDATE $table_pages SET count=count+1, lastvisitdate='$d' WHERE id = '" . $page . "'");
	
		$query2 = "SELECT ip FROM $table_stats WHERE ip = '$ip' AND pageid = '" . $page . "' AND sectionid = $section AND public = 1";
		$result2 = mysqli_query($db, $query2) or trigger_error(mysqli_error($db).'"<br>Query : "' . $query . '".',E_USER_WARNING); 
		if (mysqli_num_rows($result2) > 0)
		{
			mysqli_query($db, "UPDATE $table_stats SET count = count + 1, public = 1
							WHERE ip = '$ip' AND pageid = $page AND sectionid = '" . $section . "' AND public = 1");
		}
		else
		{
			mysqli_query($db, "INSERT INTO $table_stats(ip,received,pageid,sectionid,count,public) VALUES('$ip',now(),$page,$section,'1','1')");
		}
	}
	else
	{
		mysqli_query($db, "UPDATE $table_pages SET count=count+1, lastvisitdate='$d' WHERE id = '". $page . "'");
	
		$query2 = "SELECT ip FROM $table_stats WHERE ip = '$ip' AND pageid = '" . $page . "' AND sectionid = '" . $section . "' AND public = 0";
		$result2 = mysqli_query($db, $query2) or trigger_error(mysqli_error($db).'"<br>Query : "' . $query2 . '".',E_USER_WARNING); 
		if (mysqli_num_rows($result2) > 0)
		{
			mysqli_query($db, "UPDATE $table_stats SET count = count + 1, public = 0
							WHERE ip = '$ip' AND pageid = '". $page . "' AND sectionid = '" . $section . "' AND public = 0");
		}
		else
		{
			mysqli_query($db, "INSERT INTO $table_stats(ip,received,pageid,sectionid,count,public) VALUES('$ip',now(),$page,$section,'1','0')");
		}
	}
}
?>